"""
========================================
  Introduction to Computer Programming
========================================

-----------------------------------------------
  Lab 4
  (starter file - remove this line once edited)
  <YOUR NAMES GO HERE>
-----------------------------------------------
"""


from random import randrange


# 0. this is just like find except it takes third parameter
def find_from(s, x, start):
    """
    Returns the position that character x first occurs in string s from the
    position start onward. Returns -1 if x does not occur from that point on.

    >>> find_from('Computer Science!', 'm', 5)
    -1
    >>> find_from('Computer Science!', 'e', 5)
    6
    >>> find_from('Computer Science!', 'e', 7)
    12
    """
    pos = -1
    ...
    return pos


# 1. just like original string_slice, but works if stop is past end of s then
#    stops at end of s
def string_slice(s, start, stop):
    """
    Returns characters in s from start (inclusive) to end (exclusive). Assumes
    start and end are 0 are positive. If stop is larger than the length of s,
    the slice stops at the end of s.

    >>> string_slice('blinks', 1, 5)
    'link'
    >>> string_slice('blinks', 2, 100)
    'inks'
    """
    t = ''
    ...
    return t


# 2. contrast with insert; use string_slice
def remove(s, i):
    """
    Returns string like s but with position i removed. Assumes i >= 0 and
    i < len(s).

    >>> remove('iconic', 1)
    'ionic'
    """
    t = ...
    return t


# 3. this is a lot like string equality
def is_prefix(s, t):
    """
    Returns True if s is a prefix of t, False otherwise.

    >>> is_prefix('comp', 'computer')
    True
    >>> is_prefix('science', 'science')   # a string is a prefix of itself
    True
    >>> is_prefix('fast', 'breakfast')
    False
    >>> is_prefix('computer', 'compute')
    False
    """
    ...
    return ...


# 4. this is a bit tricky; hint: work backwards from the ends of the strings
def is_suffix(s, t):
    """
    Returns True if s is a suffix of t, False otherwise.

    >>> is_suffix('science', 'science')   # a string is a suffix of itself
    True
    >>> is_suffix('fast', 'breakfast')
    True
    >>> is_suffix('compute', 'computer')
    False
    >>> is_suffix('around', 'round')
    False
    """
    ...
    return ...


# 5. just like find_smallest, but returns index
def find_smallest_pos(s):
    """
    Returns position in string of character in s that is the "smallest"
    in terms of lexicographic order. Assumes s is not empty.

    >>> find_smallest_pos('what')
    2
    >>> find_smallest_pos('iMac')   # uppercase letters are "smaller"
    1
    """
    ...
    return ...


# 6. use a loop to: find smallest character (its position), append it to string
#    we are building, then remove it from the working string
def orderize(s):
    """
    Returns string with same collection of characters in s but in increasing
    order.

    >>> orderize('')
    ''
    >>> orderize('What?')
    '?Waht'
    >>> orderize('Amazing syzygy!')
    ' !Aaggimnsyyyzz'
    """
    t = ''
    ...
    return t


# 7.
def is_ordered(s):
    """
    Returns True if the characters in s are in increasing order (with ties
    allowed). The empty string and single characters are considered (trivially)
    ordered.

    >>> is_ordered('')
    True
    >>> is_ordered('ghost')
    True
    >>> is_ordered('!9Q_c')
    True
    >>> is_ordered('COOOOOl')
    True
    >>> is_ordered('out of order')
    False
    """
    ...
    return ...


# 8. use randrange; keep it simple
def random_char(s):
    """Returns random character from string s. Assumes s is nonempty."""
    c = ...
    return c


# 9. repeatedly call random_char
def create_random_string(s, n):
    """
    Returns a string of length n consisting of characters chosen at random from
    string s. Assumes source is nonempty.
    """
    t = ''
    ...
    return t


# 10. a little trickier; use either remove or insert (from example file)
def shuffle_string(s):
    """Returns new string that is random reordering of s."""
    ...
    return ...


# 11. this is a little like guessing in Wordle
def mesh(s, t):
    """
    Returns a string of length s that follows this rule: if corresponding
    character in s also occurs in same place in t then it appears in returned
    string; if not a '*' appears instead.

    >>> mesh('HELLO', 'HELP')
    'HEL**'
    >>> mesh('the wish', 'This is strange')
    '*h***is*'
    """
    z = ''
    ...
    return z


# 12.
def average_chars(s, t):
    """
    Returns new string that is as long as the longer of s and t and such that
    each character in the returned string correspond to the "average" of the
    two characters in the corresponding places in two strings. For instance,
    'A' and 'C' average to 'B'. If s is longer than t, the last part of the
    returned string is the last part of s; if t is longer than s, the last part
    of the returned string is the last part of t. The "average" of two
    characters should be "rounded down".

    >>> average_chars('AAA', 'CEG')
    'BCD'
    >>> average_chars('0d', '7bwhatever')
    '3cwhatever'
    """
    z = ''
    ...
    return z


# repeated from examples file
def compare(x, y):
    if x < y:
        z = -1
    elif y < x:
        z = 1
    else:
        z = 0
    return z


# 13. write a version of string_compare that returns the correct result (and
# with no errors!) even if the strings are of different lengths
def string_order(s, t):
    """Returns order (-1, 0, or 1) of string s compared to string t.

    >>> string_order('aBc', 'abc')
    -1
    >>> string_order('abc', 'aBc')
    1
    >>> string_order('ABC', 'ABC')
    0
    >>> string_order('apple', 'apples')
    -1
    >>> string_order('apples', 'apple')
    1
    """
    order = 0
    ...
    return order
